diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/MAINTAINERS ./MAINTAINERS
--- /home/jskov/kernel/dist/linux-2.2.8/MAINTAINERS	Tue May 11 11:25:22 1999
+++ ./MAINTAINERS	Sun May 16 11:35:29 1999
@@ -442,6 +442,13 @@
 L:	linux-pmac@samba.anu.edu.au
 S:	Maintained
 
+LINUX FOR POWERUP AMIGA (POWERPC/APUS)
+P:	Jesper Skov
+M:	jskov@cygnus.co.uk
+W:	http://sunsite.auc.dk/ftp/pub/os/linux/apus/docs/faq.html
+L:	linux-apus@sunsite.auc.dk
+S:	Maintained
+
 M68K
 P:	Jes Sorensen
 M:	Jes.Sorensen@cern.ch
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/Makefile ./Makefile
--- /home/jskov/kernel/dist/linux-2.2.8/Makefile	Tue May 11 11:25:22 1999
+++ ./Makefile	Sat May 15 11:36:59 1999
@@ -3,7 +3,7 @@
 SUBLEVEL = 8
 EXTRAVERSION =
 
-ARCH := m68k
+ARCH := ppc
 
 .EXPORT_ALL_VARIABLES:
 
@@ -18,7 +18,11 @@
 HOSTCC  	=gcc
 HOSTCFLAGS	=-Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
 
+ifeq (ppc,$(shell uname -m))
 CROSS_COMPILE 	=
+else
+CROSS_COMPILE 	= powerpc-unknown-linux-
+endif
 
 AS	=$(CROSS_COMPILE)as
 LD	=$(CROSS_COMPILE)ld
@@ -87,6 +91,13 @@
 #
 
 CFLAGS = -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
+
+# No -fomit-frame-pointer if compiling a kernel with KGDB support.
+ifeq ($(CONFIG_KGDB),y)
+HOSTCFLAGS = -Wall -Wstrict-prototypes -O2 -g
+CFLAGS = -Wall -Wstrict-prototypes -O2 -g
+endif
+
 
 ifdef CONFIG_SMP
 CFLAGS += -D__SMP__
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/Makefile ./arch/ppc/amiga/Makefile
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/Makefile	Fri Aug  7 15:53:32 1998
+++ ./arch/ppc/amiga/Makefile	Sat Apr  3 10:27:01 1999
@@ -12,4 +12,8 @@
             bootinfo.o amisound.o chipram.o ints.o
 OX_OBJS  := amiga_ksyms.o
 
+ifdef CONFIG_AMIGA_PCMCIA
+O_OBJS := $(O_OBJS) pcmcia.o
+endif
+
 include $(TOPDIR)/Rules.make
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/amiints.c ./arch/ppc/amiga/amiints.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/amiints.c	Sat Jan  9 18:30:34 1999
+++ ./arch/ppc/amiga/amiints.c	Sun May 16 20:07:50 1999
@@ -1,7 +1,3 @@
-/* Rename a few functions. */
-#define amiga_request_irq request_irq
-#define amiga_free_irq free_irq
-
 /*
  * linux/arch/m68k/amiga/amiints.c -- Amiga Linux interrupt handling code
  *
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/bootinfo.c ./arch/ppc/amiga/bootinfo.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/bootinfo.c	Mon Jan  4 11:30:09 1999
+++ ./arch/ppc/amiga/bootinfo.c	Mon Jan 11 21:44:38 1999
@@ -16,9 +16,11 @@
 
 extern char cmd_line[CL_SIZE];
 
-int num_memory = 0;
-struct mem_info memory[NUM_MEMINFO];
-struct mem_info ramdisk;
+extern int num_memory;
+extern int m68k_realnum_memory;
+extern struct mem_info memory[NUM_MEMINFO];
+extern struct mem_info m68k_memory[NUM_MEMINFO];
+extern struct mem_info ramdisk;
 
 extern int amiga_parse_bootinfo(const struct bi_record *);
 extern int atari_parse_bootinfo(const struct bi_record *);
@@ -42,6 +44,11 @@
 		    memory[num_memory].addr = data[0];
 		    memory[num_memory].size = data[1];
 		    num_memory++;
+
+		    /* FIXME: duplicate for m68k drivers. */
+		    m68k_memory[m68k_realnum_memory].addr = data[0];
+		    m68k_memory[m68k_realnum_memory].size = data[1];
+		    m68k_realnum_memory++;
 		} else
 		    printk("parse_bootinfo: too many memory chunks\n");
 		break;
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/chipram.c ./arch/ppc/amiga/chipram.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/chipram.c	Fri Aug  7 15:53:33 1998
+++ ./arch/ppc/amiga/chipram.c	Sun Nov 22 13:30:45 1998
@@ -1 +1,174 @@
-#include "../../m68k/amiga/chipram.c"
+/*
+**  linux/amiga/chipram.c
+**
+**      Modified 03-May-94 by Geert Uytterhoeven
+**                           (Geert.Uytterhoeven@cs.kuleuven.ac.be)
+**          - 64-bit aligned allocations for full AGA compatibility
+*/
+
+#include <linux/config.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <asm/amigahw.h>
+
+struct chip_desc {
+	unsigned first   :  1;
+	unsigned last    :  1;
+	unsigned alloced :  1;
+	unsigned length  : 24;
+	long pad;					/* We suppose this makes this struct 64 bits long!! */
+};
+
+#define DP(ptr) ((struct chip_desc *)(ptr))
+
+u_long amiga_chip_size;
+static unsigned long chipavail;
+
+unsigned long amiga_chip_avail( void )
+{
+#ifdef DEBUG
+	printk("chip_avail : %ld bytes\n",chipavail);
+#endif
+	return chipavail;
+}
+
+
+__initfunc(void amiga_chip_init (void))
+{
+  struct chip_desc *dp;
+
+  if (!AMIGAHW_PRESENT(CHIP_RAM))
+    return;
+
+#ifndef CONFIG_APUS_FAST_EXCEPT
+  /*
+   * Remove the first 4 pages where PPC exception handlers will
+   * be located.
+   */
+  amiga_chip_size -= 0x4000;
+#endif
+
+  /* initialize start boundary */
+
+  dp = DP(chipaddr);
+  dp->first = 1;
+
+  dp->alloced = 0;
+  dp->length = amiga_chip_size - 2*sizeof(*dp);
+
+  /* initialize end boundary */
+  dp = DP(chipaddr + amiga_chip_size) - 1;
+  dp->last = 1;
+  
+  dp->alloced = 0;
+  dp->length = amiga_chip_size - 2*sizeof(*dp);
+  chipavail = dp->length;  /*MILAN*/
+
+#ifdef DEBUG
+  printk ("chipram end boundary is %p, length is %d\n", dp,
+	  dp->length);
+#endif
+}
+
+void *amiga_chip_alloc (long size)
+{
+	/* last chunk */
+	struct chip_desc *dp;
+	void *ptr;
+
+	/* round off */
+	size = (size + 7) & ~7;
+
+#ifdef DEBUG
+   printk("chip_alloc: allocate %ld bytes\n", size);
+#endif
+
+	/*
+	 * get pointer to descriptor for last chunk by 
+	 * going backwards from end chunk
+	 */
+	dp = DP(chipaddr + amiga_chip_size) - 1;
+	dp = DP((unsigned long)dp - dp->length) - 1;
+	
+	while ((dp->alloced || dp->length < size)
+	       && !dp->first)
+		dp = DP ((unsigned long)dp - dp[-1].length) - 2;
+
+	if (dp->alloced || dp->length < size) {
+		printk ("no chipmem available for %ld allocation\n", size);
+		return NULL;
+	}
+
+	if (dp->length < (size + 2*sizeof(*dp))) {
+		/* length too small to split; allocate the whole thing */
+		dp->alloced = 1;
+		ptr = (void *)(dp+1);
+		dp = DP((unsigned long)ptr + dp->length);
+		dp->alloced = 1;
+#ifdef DEBUG
+		printk ("chip_alloc: no split\n");
+#endif
+	} else {
+		/* split the extent; use the end part */
+		long newsize = dp->length - (2*sizeof(*dp) + size);
+
+#ifdef DEBUG
+		printk ("chip_alloc: splitting %d to %ld\n", dp->length,
+			newsize);
+#endif
+		dp->length = newsize;
+		dp = DP((unsigned long)(dp+1) + newsize);
+		dp->first = dp->last = 0;
+		dp->alloced = 0;
+		dp->length = newsize;
+		dp++;
+		dp->first = dp->last = 0;
+		dp->alloced = 1;
+		dp->length = size;
+		ptr = (void *)(dp+1);
+		dp = DP((unsigned long)ptr + size);
+		dp->alloced = 1;
+		dp->length = size;
+	}
+
+#ifdef DEBUG
+	printk ("chip_alloc: returning %p\n", ptr);
+#endif
+
+	if ((unsigned long)ptr & 7)
+		panic("chip_alloc: alignment violation\n");
+
+    chipavail -= size + (2*sizeof(*dp)); /*MILAN*/
+
+    return ptr;
+}
+
+void amiga_chip_free (void *ptr)
+{
+	struct chip_desc *sdp = DP(ptr) - 1, *dp2;
+	struct chip_desc *edp = DP((unsigned long)ptr + sdp->length);
+
+    chipavail += sdp->length + (2* sizeof(sdp)); /*MILAN*/
+#ifdef DEBUG
+   printk("chip_free: free %ld bytes at %p\n",sdp->length,ptr);
+#endif
+	/* deallocate the chunk */
+	sdp->alloced = edp->alloced = 0;
+
+	/* check if we should merge with the previous chunk */
+	if (!sdp->first && !sdp[-1].alloced) {
+		dp2 = DP((unsigned long)sdp - sdp[-1].length) - 2;
+		dp2->length += sdp->length + 2*sizeof(*sdp);
+		edp->length = dp2->length;
+		sdp = dp2;
+	}
+
+	/* check if we should merge with the following chunk */
+	if (!edp->last && !edp[1].alloced) {
+		dp2 = DP((unsigned long)edp + edp[1].length) + 2;
+		dp2->length += edp->length + 2*sizeof(*sdp);
+		sdp->length = dp2->length;
+		edp = dp2;
+	}
+}
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/config.c ./arch/ppc/amiga/config.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/config.c	Mon Jan  4 11:30:10 1999
+++ ./arch/ppc/amiga/config.c	Sun Jan 31 11:57:25 1999
@@ -1,13 +1,12 @@
 #define m68k_debug_device debug_device
-#define m68k_num_memory num_memory
-#define m68k_memory memory
 
 #include <linux/init.h>
 
 /* machine dependent "kbd-reset" setup function */
-void (*kbd_reset_setup) (char *, int) __initdata = 0;
+void (*mach_kbd_reset_setup) (char *, int) __initdata = 0;
 
 #include <asm/io.h>
+#include <asm/system.h>
 
 /*
  *  linux/arch/m68k/amiga/config.c
@@ -42,6 +41,7 @@
 #include <asm/machdep.h>
 #include <linux/zorro.h>
 
+unsigned long powerup_PCI_present;
 unsigned long amiga_model;
 unsigned long amiga_eclock;
 unsigned long amiga_masterclock;
@@ -62,7 +62,6 @@
 /* amiga specific keyboard functions */
 extern int amiga_keyb_init(void);
 extern int amiga_kbdrate (struct kbd_repeat *);
-extern void amiga_kbd_reset_setup(char*, int);
 /* amiga specific irq functions */
 extern void amiga_init_IRQ (void);
 extern void (*amiga_default_handler[]) (int, void *, struct pt_regs *);
@@ -138,8 +137,13 @@
 
     switch (record->tag) {
 	case BI_AMIGA_MODEL:
-	    amiga_model = *data;
-	    break;
+	{
+		unsigned long d = *data;
+
+		powerup_PCI_present = d & 0x100;
+		amiga_model = d & 0xff;
+	}
+	break;
 
 	case BI_AMIGA_ECLOCK:
 	    amiga_eclock = *data;
@@ -353,7 +357,6 @@
   mach_sched_init      = amiga_sched_init;
   mach_keyb_init       = amiga_keyb_init;
   mach_kbdrate         = amiga_kbdrate;
-  kbd_reset_setup      = amiga_kbd_reset_setup;
   mach_init_IRQ        = amiga_init_IRQ;
   mach_default_handler = &amiga_default_handler;
 #ifndef CONFIG_APUS
@@ -742,7 +745,7 @@
 static void amiga_serial_putc(char c)
 {
     custom.serdat = (unsigned char)c | 0x100;
-    iobarrier_rw ();
+    mb();
     while (!(custom.serdatr & 0x2000))
        ;
 }
@@ -922,3 +925,30 @@
 
     return(len);
 }
+
+#ifdef CONFIG_APUS
+int get_hardware_list(char *buffer)
+{
+	extern int get_cpuinfo(char *buffer);
+	int len = 0;
+	char model[80];
+	u_long mem;
+	int i;
+
+	if (mach_get_model)
+		mach_get_model(model);
+	else
+		strcpy(model, "Unknown PowerPC");
+	
+	len += sprintf(buffer+len, "Model:\t\t%s\n", model);
+	len += get_cpuinfo(buffer+len);
+	for (mem = 0, i = 0; i < m68k_realnum_memory; i++)
+		mem += m68k_memory[i].size;
+	len += sprintf(buffer+len, "System Memory:\t%ldK\n", mem>>10);
+
+	if (mach_get_hardware_list)
+		len += mach_get_hardware_list(buffer+len);
+
+	return(len);
+}
+#endif
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/ints.c ./arch/ppc/amiga/ints.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/ints.c	Fri Aug  7 15:53:34 1998
+++ ./arch/ppc/amiga/ints.c	Sat Nov 21 20:38:10 1998
@@ -42,7 +42,7 @@
  * the IRQ handling routines.
  */
 
-__initfunc(void apus_init_IRQ(void))
+__initfunc(void m68k_init_IRQ(void))
 {
 	int i;
 
@@ -134,7 +134,7 @@
 	}
 }
 
-int get_irq_list(char *buf)
+int m68k_get_irq_list(char *buf)
 {
 	int i, len = 0;
 
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/pcmcia.c ./arch/ppc/amiga/pcmcia.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/pcmcia.c	Thu Jan  1 01:00:00 1970
+++ ./arch/ppc/amiga/pcmcia.c	Sun May 16 11:54:04 1999
@@ -0,0 +1 @@
+#include "../../m68k/amiga/pcmcia.c"
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/time.c ./arch/ppc/amiga/time.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/amiga/time.c	Thu Nov 19 19:16:53 1998
+++ ./arch/ppc/amiga/time.c	Sun Nov 22 21:02:04 1998
@@ -15,7 +15,7 @@
 	unsigned int day, unsigned int hour,
 	unsigned int min, unsigned int sec);
 
-unsigned long apus_get_rtc_time(void)
+unsigned long m68k_get_rtc_time(void)
 {
 	unsigned int year, mon, day, hour, min, sec;
 
@@ -30,7 +30,7 @@
 	return mktime(year, mon, day, hour, min, sec);
 }
 
-int apus_set_rtc_time(unsigned long nowtime)
+int m68k_set_rtc_time(unsigned long nowtime)
 {
   if (mach_set_clock_mmss)
     return mach_set_clock_mmss (nowtime);
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/config.in ./arch/ppc/config.in
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/config.in	Wed May 12 10:02:44 1999
+++ ./arch/ppc/config.in	Sat May 15 11:38:26 1999
@@ -22,7 +22,10 @@
 bool 'Symmetric multi-processing support' CONFIG_SMP
 if [ "$CONFIG_ALL_PPC" != "y" ];then
   define_bool CONFIG_MACH_SPECIFIC y
+else
+  bool 'Include APUS support' CONFIG_APUS
 fi
+
 endmenu
 
 if [ "$CONFIG_MBX" = "y" ];then
@@ -40,7 +43,11 @@
 fi
 
 if [ "$CONFIG_APUS" = "y" ]; then
-  define_bool CONFIG_PCI n
+  if [ "$CONFIG_MACH_SPECIFIC" = "y" ];then
+    define_bool CONFIG_APUS_FAST_EXCEPT y
+  else
+    define_bool CONFIG_PCI y
+  fi
 else
   define_bool CONFIG_PCI y
 fi
@@ -99,14 +106,15 @@
 fi
 
 if [ "$CONFIG_APUS" = "y" ]; then
-  define_bool CONFIG_FB_CONSOLE y
   define_bool CONFIG_AMIGA y
   define_bool CONFIG_ZORRO y
   define_bool CONFIG_AMIGAMOUSE y
-  define_bool CONFIG_ABSTRACT_CONSOLE y
-  define_bool CONFIG_FB y
+  if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
+    bool 'Amiga 1200/600 PCMCIA support' CONFIG_AMIGA_PCMCIA
+  fi
+
+  # Serial
   tristate 'Amiga builtin serial support' CONFIG_AMIGA_BUILTIN_SERIAL
-  tristate 'Parallel printer support' CONFIG_M68K_PRINTER
   tristate 'GVP IO-Extender support' CONFIG_GVPIOEXT
   dep_tristate 'GVP IO-Extender parallel printer support' CONFIG_GVPIOEXT_LP $CONFIG_GVPIOEXT
   dep_tristate 'GVP IO-Extender PLIP support' CONFIG_GVPIOEXT_PLIP $CONFIG_GVPIOEXT
@@ -115,6 +123,35 @@
        "$CONFIG_MULTIFACE_III_TTY" = "y" ]; then
     bool 'Support for serial port console' CONFIG_SERIAL_CONSOLE
   fi
+  if [ "$CONFIG_AMIGA_PCMCIA" = "y" ]; then
+    tristate 'Hisoft Whippet PCMCIA serial support' CONFIG_WHIPPET_SERIAL
+  fi
+
+  # Parallel
+  if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
+    tristate 'Parallel port support (EXPERIMENTAL, disables old lp driver!)' CONFIG_PARPORT
+    if [ "$CONFIG_PARPORT" != "n" ]; then
+      if [ "$CONFIG_AMIGA" != "n" ]; then
+        dep_tristate '   Amiga builtin port' CONFIG_PARPORT_AMIGA $CONFIG_PARPORT
+        if [ "$CONFIG_ZORRO" != "n" ]; then
+          dep_tristate '    Multiface III parallel port' CONFIG_PARPORT_MFC3 $CONFIG_PARPORT
+        fi
+      fi
+    fi
+  fi
+  if [ "$CONFIG_PARPORT" = "n" ]; then
+    tristate 'Parallel printer support' CONFIG_M68K_PRINTER
+    if [ "$CONFIG_ZORRO" = "y" ]; then
+      dep_tristate 'Multiface Card III parallel support' CONFIG_MULTIFACE_III_LP $CONFIG_M68K_PRINTER
+    fi
+  else
+    dep_tristate 'Parallel printer support' CONFIG_PRINTER $CONFIG_PARPORT
+    if [ "$CONFIG_PRINTER" != "n" ]; then
+      bool '  Support IEEE1284 status readback' CONFIG_PRINTER_READBACK
+    fi
+  fi   
+
+  # Misc
   bool 'Use power LED as a heartbeat' CONFIG_HEARTBEAT
   bool '/proc/hardware support' CONFIG_PROC_HARDWARE
 fi
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/Makefile ./arch/ppc/kernel/Makefile
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/Makefile	Tue May 11 11:26:14 1999
+++ ./arch/ppc/kernel/Makefile	Sat May 15 11:39:25 1999
@@ -15,10 +15,8 @@
 
 
 O_OBJS := traps.o irq.o idle.o time.o process.o signal.o syscalls.o misc.o \
-	  bitops.o ptrace.o align.o ppc_htab.o
-ifdef CONFIG_PCI
-O_OBJS += pci.o
-endif
+	  bitops.o ptrace.o align.o ppc_htab.o pci.o
+
 ifdef CONFIG_KGDB
 O_OBJS += ppc-stub.o
 endif
@@ -29,18 +27,12 @@
 ifeq ($(CONFIG_MBX),y)
 O_OBJS += mbx_setup.o mbx_pci.o softemu8xx.o i8259.o ppc8xx_pic.o
 else
-ifeq ($(CONFIG_APUS),y)
-O_OBJS += apus_setup.o prom.o openpic.o
-else
-ifneq ($(CONFIG_MBX),y)
 O_OBJS += prep_time.o pmac_time.o chrp_time.o \
 	  pmac_setup.o pmac_support.o \
 	  prep_pci.o pmac_pci.o chrp_pci.o \
-	  residual.o prom.o openpic.o feature.o \
+	  residual.o prom.o openpic.o feature.o apus_setup.o \
 	  prep_nvram.o open_pic.o i8259.o pmac_pic.o indirect_pci.o
 OX_OBJS += chrp_setup.o prep_setup.o
-endif
-endif
 endif
 
 ifdef CONFIG_SMP
